{$mode objfpc}{$R-}{$H+}{$assertions on}
uses
  Math;
type
PElem = ^TElem;
TElem = record
  cnt: Integer;
  next: array ['0'..'1'] of PElem;
end;
var
  L, i, M: Integer;
  s: String;
  tree: PElem = nil;
  path: array of PElem;

  function Find(start: Integer): PElem;
  var
    p: PElem;

    procedure M(var r: PElem); inline;
    begin
      if r = nil then begin
        New(r);
        FillChar(r^, SizeOf(r^), 0);
      end;
      p := r;
    end;

  var
    j: Integer;
  begin
    p := tree;
    for j := 0 to L - 1 do begin
      path[j] := p;
      M(p^.next[s[start + j]]);
    end;
    Result := p;
  end;

  function CntDef(a: PElem): Integer; inline;
  begin
    if a = nil then Result := 0 else Result := a^.cnt;
  end;

  procedure Update;
  var
    j: Integer;
  begin
    for j := L - 1 downto 0 do
      with path[j]^ do
        cnt := Max(CntDef(next['0']), CntDef(next['1']));
  end;

begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Readln(L, M);
  Readln(s);
  Assert((1 <= M) and (L <= M) and (M <= Length(s)) and (1 <= L));
  New(tree);
  FillChar(tree^, SizeOf(tree^), 0);
  SetLength(path, L);
  for i := 1 to Length(s) - L + 1 do begin
    if i > M then begin
      Find(i - M)^.cnt -= 1;
      Update;
    end;
    Find(i)^.cnt += 1;
    Update;
    if i + L > M then
      Write(tree^.cnt, ' ');
  end;
end.
